#!/usr/bin/python

#########################################
# This file showcases the use of pexpect
# for writing shell-interactive programs.
#########################################

import pexpect

# we call the target program, as you would do in bash
prog = pexpect.spawn('./sidechannel')

# expect-like statements probes the program's output
## expect_exact looks for an exact occurence of a string
prog.expect_exact ('>> Password: ')

# we can send input via sendline
prog.sendline('pass1234')

## expect operates in a similar fashion to expect_exact
## but allows for regular expressions
## see http://docs.python.org/2/library/re.html
prog.expect('\[.*\]')
## the result of the match can be found in the 'after' attribute
## (we trim the [ and ])
time = prog.after[1:-1]

# let's see what we got
print 'Got time: ' + time

# If (at any point) we want to give the control back to the user
# we use interact
prog.expect_exact ('>> Password: ')
## You can do stuff here!
prog.interact()
